<?php

namespace web\admin\ap;

class usr_invoicing {
    static function setwhere($db, $post) {
        $query = $post->get('query');
        $csql = new \ciy\sql('ap_usr_invoicing');
        $liid = objint($query, 'liid');
        if ($liid == 1)
            $csql->where('invtimes=0');
        if ($liid == 2)
            $csql->where('invtimes>0');
        $val = objstr($query, 'vuser');
        if (!empty($val)) {
            $csqlt = new \ciy\sql('ap_user');
            $csqlt->where('name like', $val);
            $trow = $db->getone($csqlt);
            if (is_array($trow)) {
                $csql->where('vuser', $trow['id']);
                $query['vuser'] = $trow['name'];
            } else {
                $csql->where('vuser=0');
            }
        }
        $csql->wherenumrange('invoicemoney', objstr($query, 'invoicemoney_1'), objstr($query, 'invoicemoney_2'), 100);
        $csql->where('name like', objstr($query, 'name'));
        $csql->where('taxnumber like', objstr($query, 'taxnumber'));
        $csql->wheredaterange('addtimes', objstr($query, 'addtimes'));
        $csql->wheredaterange('invtimes', objstr($query, 'invtimes'));
        $val = objstr($query, 'invuser');
        if (!empty($val)) {
            $csqlt = new \ciy\sql('zc_cata');
            $csqlt->where('cbid in (select id from zc_cata where cbid=0 and codeid=\'invuser\')');
            $csqlt->where('name like', $val);
            $trow = $db->getone($csqlt);
            if (is_array($trow)) {
                $csql->where('invuser', $trow['codeid']);
                $query['invuser'] = $trow['name'];
            } else {
                $csql->where('invuser=0');
            }
        }
        $order = objstr($query, 'order', 'id desc');
        $csql->order($order);
        $query['order'] = $order;
        return [$query, $csql];
    }

    public static function json_list() {
        global $db;
        $rsuser = verifyfast();
        $post = new \ciy\post();
        list($where, $csql) = self::setwhere($db, $post);
        $pageno = $post->getint('pageno', 1);
        $pagecount = $post->getint('pagecount', 10);
        $csql->limit($pageno, $pagecount);
        $mainrowcount = $post->getint('count');
        $rows = $db->get($csql, $mainrowcount);
        if($rows === false)
            return errjson($db->error);
        $ret = array('where' => $where, 'pageno' => $pageno, 'pagecount' => $pagecount, 'count' => $mainrowcount, 'list' => $rows);
        if ($post->getbool('field')) {
            $field = array();
            $fshow = $db->getfield($field, 'ap_usr_invoicing');
            foreach ($field as $fr => $v) {
                if (get('_' . $fr))
                    $field[$fr]['c'] = ',' . $field[$fr]['c'];
            }
            $fshow = fieldadd($fshow, $field, 0, '_btn', '操作');
            $ret['field'] = $field;
            $ret['fshow'] = $fshow;
        }
        if ($post->getbool('once')) {
            $ret['once'] = array();
            $input = array();
            $input[] = array('type' => 'input', 'form' => 'vuser', 'name' => '所属用户', 'prop' => ' style="width:8em;"');
            $input[] = array('type' => 'num', 'form' => 'invoicemoney', 'name' => '开票金额', 'prop' => ' style="width:4em;"');
            $input[] = array('type' => 'input', 'form' => 'name', 'name' => '名称', 'prop' => ' style="width:8em;"');
            $input[] = array('type' => 'input', 'form' => 'taxnumber', 'name' => '税号', 'prop' => ' style="width:8em;"');
            $input[] = array('type' => 'daterange', 'form' => 'addtimes', 'name' => '申请时间');
            $input[] = array('type' => 'daterange', 'form' => 'invtimes', 'name' => '开票时间');
            $input[] = array('type' => 'input', 'form' => 'invuser', 'name' => '开票人', 'prop' => ' style="width:8em;"');
            $ret['once']['input'] = $input;
        }
        $ret['ap_user'] = getrelation($db, $rows, 'ap_user', 'vuser');
        $ret['ap_usr_invoicetitle'] = getrelation($db, $rows, 'ap_usr_invoicetitle', 'invoicetitleid');
        return succjson($ret);
    }
    public static function json_update() {
        global $db;
        $rsuser = verifyfast();
        //if (nopower($db, $rsuser['id'], 'p u'))
        //    return errjson('您未被授权操作');
        $post = new \ciy\post();
        $id = $post->getint('id');
        $invfile = $post->get('invfile');
        if (empty($invfile))
            return errjson('请填写发票');
        $csql = new \ciy\sql('ap_usr_invoicing');
        $csql->where('id', $id);
        $datarow = $db->getone($csql);
        if (!is_array($datarow))
            return errjson('数据不存在');
        try {
            $db->begin();
            $updata = array();
            $updata['invtimes'] = tostamp();
            $updata['invuser'] = $rsuser['id'];
            $updata['invfile'] = $invfile;
            $csql = new \ciy\sql('ap_usr_invoicing');
            $csql->where('id', $id);
            if ($db->update($csql, $updata) === false)
                throw new \Exception('更新失败:' . $db->error);
            $updata['id'] = $id;
            savelogdb($db, $rsuser['id'], 'ap_usr_invoicing', $datarow, $updata);
            $db->commit();
        } catch (\Exception $ex) {
            $db->rollback();
            savelogfile('err_db', $ex->getMessage());
            return errjson($ex->getMessage());
        }
        $ret['data'] = $updata;
        $ret['ap_user'] = getrelation($db, [$updata], 'ap_user', 'vuser');
        $ret['ap_usr_invoicetitle'] = getrelation($db, [$updata], 'ap_usr_invoicetitle', 'invoicetitleid');
        return succjson($ret);
    }

    public static function json_del() {
        global $db;
        $rsuser = verifyfast();
        //if (nopower($db, $rsuser['id'], 'p d'))
        //    return errjson('您未被授权操作');
        $post = new \ciy\post();
        $ids = $post->get('ids');
        if (empty($ids))
            return errjson('请选择至少一条');
        $csql = new \ciy\sql('ap_usr_invoicing');
        $csql->where('id in', $ids);
        $rows = $db->get($csql);
        $vids = array();
        try {
            $db->begin();
            foreach ($rows as $row) {
                $delid = $row['id'];
                //delcheck($db, $delid, 'tablexx', 'xxid', '管理员');
                //delall($db, $delid, 'tablexx', 'xxid', '运动员');  //deltimeall
                delme($db, $delid, 'ap_usr_invoicing');
                savelogdb($db, $rsuser['id'], 'ap_usr_invoicing', $row, null);
                $vids[] = $delid;
            }
            $db->commit();
        } catch (\Exception $ex) {
            $db->rollback();
            savelogfile('err_db', $ex->getMessage());
            return errjson($ex->getMessage());
        }
        $ret['ids'] = $vids;
        return succjson($ret);
    }

    public static function json_exportxls() {
        global $db;
        $rsuser = verifyfast();
        //if (nopower($db, $rsuser['id'], 'p e'))
        //    return errjson('您未被授权操作');
        $post = new \ciy\post();
        list($where, $csql) = self::setwhere($db, $post);
        $rows = $db->get($csql);
        if (count($rows) > 10000)
            return errjson('将导出' . count($rows) . '条，不建议超过1万条，请筛选缩小范围');
        $fields = array();
        $fields[] = array('style' => 'l', 'width' => 60,  'field' => 'id', 'name' => '行码');
        $fields[] = array('style' => 'l', 'width' => 100,  'field' => 'vuser', 'name' => '所属用户');
        $fields[] = array('style' => 'r', 'width' => 100,  'field' => 'invoicemoney', 'name' => '开票金额');
        $fields[] = array('style' => 'l', 'width' => 100,  'field' => 'invoicetitleid', 'name' => '所属抬头');
        $fields[] = array('style' => 'l', 'width' => 150,  'field' => 'name', 'name' => '名称');
        $fields[] = array('style' => 'l', 'width' => 150,  'field' => 'taxnumber', 'name' => '税号');
        $fields[] = array('style' => 'l', 'width' => 150,  'field' => 'addr', 'name' => '单位地址');
        $fields[] = array('style' => 'l', 'width' => 150,  'field' => 'phone', 'name' => '电话号码');
        $fields[] = array('style' => 'l', 'width' => 150,  'field' => 'bankname', 'name' => '银行名称');
        $fields[] = array('style' => 'l', 'width' => 150,  'field' => 'bankaccount', 'name' => '银行账号');
        $fields[] = array('style' => 'l', 'width' => 100,  'field' => 'addtimes', 'name' => '申请时间');
        $fields[] = array('style' => 'l', 'width' => 100,  'field' => 'invtimes', 'name' => '开票时间');
        $fields[] = array('style' => 'l', 'width' => 100,  'field' => 'invuser', 'name' => '开票人');
        $fields[] = array('style' => 'l', 'width' => 150,  'field' => 'invfile', 'name' => '发票');
        $code_vuser = getrelation($db, $rows, 'ap_user', 'vuser', 'id,name');
        $code_invoicetitleid = getrelation($db, $rows, 'ap_usr_invoicetitle', 'invoicetitleid', 'id,name');
        $code_invuser = getcatas($db, 'adminuser');
        $datas = array();
        foreach ($rows as $row) {
            $dat = array();
            foreach ($fields as $field) {
                $field = $field['field'];
                $val = isset($row[$field]) ? $row[$field] : '';
                if ($field == 'id')
                    $val = enid($val);
                if ($field == 'vuser')
                    $val = ccode($code_vuser, $val);
                if ($field == 'invoicemoney')
                    $val = number_format($val / 100, 2);
                if ($field == 'invoicetitleid')
                    $val = ccode($code_invoicetitleid, $val);
                if ($field == 'addtimes')
                    $val = ($val == 0 ? '--' : date('Y-m-d H:i', $val));
                if ($field == 'invtimes')
                    $val = ($val == 0 ? '--' : date('Y-m-d H:i', $val));
                if ($field == 'invuser')
                    $val = ccode($code_invuser, $val);
                $dat[] = $val;
            }
            $datas[] = $dat;
        }
        $param = array();
        $param['field'] = $fields;
        $param['data'] = $datas;
        $param['sheetname'] = '数据报表';
        $param['titleheight'] = '25'; //列头高度
        $param['landscape'] = true; //横向打印
        $param['fixtopage'] = true; //打印整个工作表
        $param['toptitle'] = 'Demo数据报表';
        $str = \ciy\excel::general_excel_xml($param);
        $filename = '';
        if (empty($filename))
            $filename = date('Y-m-d_H-i-s') . rand(1000, 9999);
        $filename .= '.xls';
        file_put_contents(PATH_WEB . 'ud/tmp/' . $filename, $str);
        return succjson(array('url' => '/ud/tmp/' . $filename));
    }
}
